SystemOrganization addCategory: #'Xpf-ExposingMorphs'!

AlignmentMorph subclass: #SelectableList
	instanceVariableNames: 'collection listMorph selectedIndex selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ExposingMorphs'!

!SelectableList methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:30'!
collection
	<bindableAsCollection>
	
	^ collection! !

!SelectableList methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:30'!
collection: anObject
	<bindableAsCollection>
	
	collection := anObject! !

!SelectableList methodsFor: 'initialization' stamp: 'topa 1/17/2010 20:33'!
initialize
	super initialize.
	
	"set default values"
	self collection: #(test1 test2 test3).
	self selectedIndex: self collection size.
	
	"initialize list morph"
	self listMorph: (PluggableListMorph new hResizing: #spaceFill).
			
	self bind: #collection to: self listMorph with: #list.

	"initialize graphical representation"
	self
		color: Color white;
		layoutInset: 0;
		wrapCentering: #center;
		cellPositioning: #leftCenter;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		extent: 400@200.
		
	self addMorphBack: self list.
! !

!SelectableList methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:31'!
listMorph

	^ listMorph! !

!SelectableList methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:31'!
listMorph: anObject

	listMorph := anObject! !

!SelectableList methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:30'!
selected
	^ selected! !

!SelectableList methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:30'!
selected: anObject
	selected := anObject! !

!SelectableList methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:30'!
selectedIndex
	^ selectedIndex! !

!SelectableList methodsFor: 'accessing' stamp: 'topa 1/17/2010 20:30'!
selectedIndex: anObject
	selectedIndex := anObject.
	self selected: (self collection at: anObject).
	self changed: #selectedIndex.! !

AlignmentMorph subclass: #SelectableListTraditional
	instanceVariableNames: 'collection list selectedIndex selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ExposingMorphs'!

!SelectableListTraditional methodsFor: 'accessing' stamp: 'AK 1/17/2010 19:24'!
collection
	<bindableAsCollection>
	
	^ collection! !

!SelectableListTraditional methodsFor: 'accessing' stamp: 'AK 1/17/2010 19:24'!
collection: anObject
	<bindableAsCollection>
	
	collection := anObject! !

!SelectableListTraditional methodsFor: 'initialization' stamp: 'amb 1/17/2010 17:56'!
initialize
	super initialize.
	
	"set default values"
	self collection: #(test1 test2 test3).
	self selectedIndex: self collection size.
	
	"initialize list morph"
	self list: (PluggableListMorph
		on: self
		list: #collection
		selected: #selectedIndex
		changeSelected: #selectedIndex:
		menu: nil
		keystroke: nil).
		
	"initialize graphical representation"
	self list hResizing: #spaceFill.
	self
		color: Color white;
		layoutInset: 0;
		wrapCentering: #center;
		cellPositioning: #leftCenter;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		extent: 400@200.
		
	self addMorphBack: self list.
! !

!SelectableListTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 17:33'!
list
	^ list! !

!SelectableListTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 17:33'!
list: anObject
	list := anObject! !

!SelectableListTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 17:34'!
selected
	^ selected! !

!SelectableListTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 17:34'!
selected: anObject
	selected := anObject! !

!SelectableListTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 17:34'!
selectedIndex
	^ selectedIndex! !

!SelectableListTraditional methodsFor: 'accessing' stamp: 'amb 1/17/2010 18:52'!
selectedIndex: anObject
	selectedIndex := anObject.
	self selected: (self collection at: anObject).
	self changed: #selectedIndex.! !

SimpleSliderMorph subclass: #ExposingSlider
	instanceVariableNames: 'val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-ExposingMorphs'!

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:24'!
maxVal
	<bindable>
	^ self valueOfVariableNamed: #maxVal! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:24'!
maxVal: anObject
	<bindable>
	self setVariableNamed: #maxVal toValue: anObject.! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:20'!
minVal
	<bindable>
	^ self valueOfVariableNamed: #minVal! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:22'!
minVal: anObject
	<bindable>
	self setVariableNamed: #minVal toValue: anObject.! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 09:39'!
val
      <bindable>
	^ self valueOfVariableNamed: #val.! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 08:34'!
val: anVal
      <bindable>
	self setVariableNamed: #val toValue: anVal.! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 09:40'!
value
	<bindable>
	^ self valueOfVariableNamed: #value.
! !

!ExposingSlider methodsFor: 'accessing' stamp: 'AK 1/5/2010 10:05'!
value: newValue
	<bindable>
	"Drive the slider position externally..."
	self setVariableNamed: #value toValue: (newValue min: 1.0 max: 0.0).
	self computeSlider! !
